<?
function template_create($name,$desc,$mlid,$file = "", $folder_id = "", $ml = "", $lock = true, $channel_id = false) {
 global $TIME,$USER_ID,$FOLDER_ID,$W_CREATE, $ERROR, $DIC, $T_TEMPLATE, $T_FOLDER, $NODE_ID, $FEATURE;

 if (!$folder_id) $folder_id = $FOLDER_ID;

 
 $folder = new CNFolderObject($folder_id);
 $folder_id = $folder->getMasterId();

 if (template_exists($name,$folder_id)) {
 $ERROR["name"] = i18n('a_template_with_this_name');
 return false;
 }
 
 
 $sql = "INSERT INTO templategroup (nada) VALUES (0)";
 $rs = query($sql);
 $tgid = $rs["iid"];

 
 $name = sqlslashes($name);
 $desc = sqlslashes($desc);
 $ml = sqlslashes($ml);
 $locked = $lock?$TIME:0;
 $lockedby = $lock?$USER_ID:0;

 
 $folderinfo = get_folderinfo($folder_id);
 if (!$FEATURE["multichannelling"]) {
 $channel_id = 0;
 } else if ($channel_id === false) {
 $channel_id = $FEATURE["multichannelling"] && $folderinfo["node_id"] != $NODE_ID ? $NODE_ID : 0;
 }

 
 $channelsetId = createChannelsetId();

 $sql = "INSERT INTO template (folder_id,name,locked,locked_by,ml_id,creator,cdate,editor,edate,description, templategroup_id, ml, channel_id, channelset_id)
VALUES (".sqlf_tl_num($folder_id).",'$name',".sqlf_tl_num($locked).",".sqlf_tl_num($lockedby).",".sqlf_tl_num($mlid).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",'$desc',".sqlf_tl_num($tgid).",'$ml', ".sqlf_tl_num($channel_id).", ".sqlf_tl_num($channelsetId).")";
 $rs = query($sql);
 $tid = $rs["iid"];

 
 $sql = "INSERT INTO template_folder (template_id, folder_id) VALUES (".sqlf_tl_num($tid).", ".sqlf_tl_num($folder_id).")";
 query($sql);

 
 logcmd($W_CREATE,$T_TEMPLATE,$tid,$folder_id,"template_create");

 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_FOLDER, $folder_id);
 
 return $tid;
}

function template_update($tid,$name,$desc,$ml,$file = "") {
 global $TIME,$USER_ID,$FOLDER_ID, $W_EDIT, $T_TEMPLATE, $ERROR, $DIC, $FEATURE;

 if (!$tid) halt(7,"template_update: no id to update: tid($tid)");
 if (template_exists($name,$FOLDER_ID,$tid)) {
 $ERROR["name"] = i18n('a_template_with_this_name');
 return false;
 }

 $name = sqlslashes($name);
 $desc = sqlslashes($desc);
 
 $sql = "UPDATE template SET folder_id = ".sqlf_tl_num($FOLDER_ID).", name = '$name', locked = ".sqlf_tl_num($TIME).", locked_by = ".sqlf_tl_num($USER_ID).", ml_id = ".sqlf_tl_num($ml).",
editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", description = '$desc' WHERE id = ".sqlf_tl_num($tid);
 query($sql);

 logcmd($W_EDIT,$T_TEMPLATE,$tid,$FOLDER_ID,"template_update");

 
 if ($FEATURE["javaparser"]) {
 global $T_TEMPLATE;
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_TEMPLATE, $tid);
 }

 return $tid;
}

function template_value($tpl_id, $value) {

 global $TIME,$USER_ID,$FOLDER_ID, $W_EDIT, $T_TEMPLATE, $FEATURE;

 if (!$tpl_id) halt(7,"template_update: no id to update: tid($tpl_id)");

 $value = sqlslashes($value);
 $sql = "UPDATE template SET ml = '$value' WHERE id = ".sqlf_tl_num($tpl_id);
 query($sql);

 logcmd($W_EDIT,$T_TEMPLATE,$tpl_id,$FOLDER_ID,"template_value");

 
 if ($FEATURE["javaparser"]) {
 global $T_TEMPLATE;
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_TEMPLATE, $tpl_id);
 }

 return $tpl_id;

}

function template_exists($name,$folder_id, $id = 0) {
 
 $name = sqlslashes($name);

 if ($id) {
 $sql = "SELECT folder_id FROM template_folder WHERE template_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $arr = $rs["arr"];
 } else {
 $arr = array(array("folder_id"=>$folder_id));
 }
 
 if ($arr) {
 while (list($key,$val) = each($arr)) {
 $sql = "SELECT count(template.id) AS c FROM template,template_folder WHERE template.id = template_folder.template_id AND template_folder.folder_id = ".sqlf_tl_num($val["folder_id"])." AND template.name = '$name' and template.id != ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) return true; 
 else return false;
 }
 }
}







function template_del($ids,$folder_id) {

 if (!(is_array($ids))) halt(7,"template_del: no valid array of template_ids to delete: ids($ids)");

 global $ERROR;

 $error = false;
 if (!empty($ids)) {
 
 $javaParser =& CodeParser::getJavaParser();
 $ERROR = $javaParser->unlinkTemplate(array_keys($ids), $folder_id);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 }

 return !$error;
}






function template_is_inherited($ids) {
 global $FEATURE, $NODE_ID;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 $nodeinfo = get_nodeinfo($NODE_ID);
 
 if ($nodeinfo["master_id"] > 0) {
 $sql = "SELECT count(*) c FROM template WHERE id IN (".sqlf_value_list(implode(",", array_keys($ids))).") AND channel_id != ".sqlf_tl_num($NODE_ID);
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 
 return false;
 }
 } else {
 return false;
 }
}






function template_has_localized_copy($ids) {
 global $FEATURE;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 
 $sql = "SELECT count(*) c FROM template t1 left join template t2 ON t1.channelset_id = t2.channelset_id WHERE t1.id in (".
 sqlf_value_list(implode(",", array_keys($ids))).") AND t1.is_master = 1 and t2.is_master = 0";

 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 return false;
 }
}









function cmd_template_link($ids,$folder_id, $recursive = "") {

 if (!is_array($ids) || (!$folder_id && (!is_array($folder_id)))) halt(7,"cmd_template_link: invalid ids($ids) or folder_id($folder_id)");

 
 $templateMasterIds = array();
 foreach ($ids as $templateId => $val) {
 $cnTemplateObject = new CNTemplateObject($templateId);
 
 if (!is_array($folder_id)) {
 $folder = get_folderinfo($folder_id);
 $template = get_templateinfo($cnTemplateObject->getMasterId());
 
 if ($template["channel_id"] > 0) {
 
 $masterNodes = getMasterNodes($template["channel_id"]);
 
 if ($template["channel_id"] != $folder["node_id"] && !in_array($folder["node_id"], $masterNodes)) {
 continue;
 }
 }
 }
 $templateMasterIds[$cnTemplateObject->getMasterId()] = $val;
 }
 $ids = $templateMasterIds;

 if (is_array($folder_id)) {
 
 arsort($folder_id);
 
 while (list($key,$val) = each($folder_id)) {
 $folder = new CNFolderObject($key);
 $key = $folder->getMasterId();
 if ($val) {
 cmd_template_link($ids, $key);
 } else {
 template_del($ids, $key);
 }
 }
 } else {
 global $USER_ID, $T_FOLDER, $ERROR;
 
 $folder = new CNFolderObject($folder_id);
 $folder_id = $folder->getMasterId();

 
 if ( perm( $USER_ID, $T_FOLDER, $folder_id, 21 ) ) {
 reset($ids);
 while (list($key,$val) = each($ids)) {
 
 $rs = query("SELECT *
				FROM template_folder tf
				INNER JOIN template t1 ON tf.template_id = t1.id
				WHERE tf.folder_id = " . sqlf_tl_num($folder_id) . "
				AND t1.name = (SELECT name FROM template where id = " . sqlf_tl_num($key) . ")");
 if ($rs["num"] > 1) {
 $finfo = get_folderinfo($folder_id);
 $ERROR = i18n("link_template_name_conflict") . ' "' . $rs["arr"][0]["name"] . '" (' . i18n("folder") . ': ' . $finfo["name"] . ')';
 return false;
 }
 
 $sql = "SELECT count(template_id) AS c FROM template_folder
  				WHERE template_id = ".sqlf_tl_num($key)." AND folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql, true);
 if ($rs["arr"][0]["c"] == 0) {
 $sql = "INSERT INTO template_folder (template_id, folder_id) VALUES (".sqlf_tl_num($key).",".sqlf_tl_num($folder_id).")";
 $rs = query($sql);
 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_FOLDER, $folder_id);
 }
 }
 } else {
 warning( 7, "User ($USER_ID) doesn't have permissions to link templates into folder ( $folder_id )!" );
 }
 
 if ($recursive) {
 $sql = "SELECT id FROM folder where mother = ".sqlf_tl_num($folder_id);
 $rs = query($sql, true);
 if ($rs["num"]>0)
 while (list($k,$v) = each($rs["arr"])) {
 cmd_template_link($ids, $v["id"], $recursive);
 }
 }
 }
 return true;
}










function cmd_template_copy($template_id, $folder_id, $newname = "", $channelId = false) {
 global $USER_ID, $T_FOLDER, $W_COPY, $T_TEMPLATE, $TIME, $FEATURE;
 
 
 if (is_array($template_id)) {
 $ids = array();
 foreach ($template_id as $id=>$val) {
 if (!$val) continue;
 $_id = cmd_template_copy($id, $folder_id, "", $channelId);
 if ($_id) $ids[$_id] = true;
 }
 return $ids;
 }
 
 if ( ! perm_can_view_template($template_id) ) {
 halt(7, "no view perms to copy template $template_id into folder $folder_id");
 }

 
 if (!perm($USER_ID, $T_FOLDER, $folder_id, 16)) {
 warning( 7, "User ($USER_ID) doesn't have permissions to copy templates into folder ( $folder_id )!" );
 $ERROR = i18n("You don't have permissions to create a template here.");
 return 0;
 }

 if (!$folder_id) halt(7, "template_copy: no folder_id($folder_id) template_id($template_id).");
 
 
 $sql = "SELECT * FROM template WHERE id = ".sqlf_tl_num($template_id);
 $rs = query($sql);
 if ($rs["num"] == 0) {
 $ERROR = i18n("The template does not exist any more.");
 return 0;
 }
 $r = $rs["arr"][0];
 $name = $r["name"];

 
 if (!$newname) {
 $i = 1;
 while (true) {
 $newname = i18n("Copy{0} of {1}", 0, ($i > 1)?" $i":"", $name);
 
 $sql = "SELECT id FROM template WHERE name = \"".sqlslashes($newname)."\"";
 $rs = query($sql);
 if ($rs["num"]) $i++;
 else break;
 }
 }
 
 
 $new_id = template_create($newname,$r["description"],$r["ml_id"],$file, $folder_id, $r["ml"], false, $channelId !== false && $FEATURE["multichannelling"] ? $channelId : 0);

 
 node_include("tag_copy");
 
 content_duplicate($template_id, 0, $new_id, "template");

 
 if ($FEATURE["template_objprop"]) {
 $sql = "SELECT id FROM objtag WHERE obj_id = ".sqlf_tl_num($template_id)." AND obj_type = ".sqlf_tl_num($T_TEMPLATE);
 $rs = query($sql);
 if (is_array($rs["arr"])) {
 while (list($key,$row) = each($rs["arr"])) {
 tag_duplicate($row["id"], "obj", $new_id);
 }
 }
 }

 logcmd($W_COPY, $T_TEMPLATE, $new_id, $folder_id, "template_copy ($template_id)" );

 trigger_event("ontemplatecopy",array("template_id"=>$template_id,"new_template_id"=>$new_id,"to_folder_id"=>$folder_id));

 





 
 
 return $new_id;
}


function get_folder_rec ($folder_id, $rec) {

}

function cmd_template_parse($id) {

global $TAG_PREFIX, $NODE_ID, $META_TAGS, $T_TEMPLATE;

$hasChanged = FALSE;
$prelen = strlen($TAG_PREFIX);

$sql = "SELECT ml FROM template WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);
$code = $rs["arr"][0]["ml"];

$offset = 0;
while (!is_false(strpos($code,"<$TAG_PREFIX",$offset))) {
 $pos1 = strpos($code,"<$TAG_PREFIX",$offset);
 $pos2 = strpos($code,">",$pos1);

 $fulltag = substr($code,$pos1, $pos2 - $pos1 + 1);
 
 $tagname = substr($fulltag, $prelen+2, strlen($fulltag) - ($prelen + 3));
 
 if (!is_false(strpos($tagname,".")) || !is_false(strpos($tagname, ":")) || $META_TAGS[$tagname] ) {
 $offset = $pos1 + 1;
 continue;
 }

 $sql = "SELECT id, construct_id FROM templatetag WHERE template_id = ".sqlf_tl_num($id)." and name = '".sqlslashes($tagname)."'";
 $rs = query($sql);
 $tag_id = $rs["arr"][0]["id"];
 
 if ($posds = strpos($code,"</$TAG_PREFIX ".$tagname.">",$offset)) {
 $sql = "SELECT part.construct_id FROM construct_node, part WHERE construct_node.construct_id = part.construct_id AND construct_node.node_id = ".sqlf_tl_num($NODE_ID)." AND part.type_id = 13";
 $rs = query($sql);
 $dscid = $rs["arr"][0]["construct_id"];
 if (!$tag_id) $tag_id = cmd_ds_create($tagname,$tgid,"template",$dscid);
 $ds_code = substr($code,$pos2 + 1, $posds - $pos2 - 1);
 $hasChanged = cmd_ds_code_update($tag_id,$ds_code) || $hasChanged;
 $pos1 = $posds;

 
 } else if (!$tag_id) {
 
 global $NODE_ID;
 
 
 $where = get_visible_constructs("id",$NODE_ID);
 $sql = "SELECT id, keyword, autoenable FROM construct WHERE $where";
 $rs = query($sql,true);
 
 
 $_l = 0;
 $cid = 1;
 $enabled = 3;
 
 $constructIds = array();
 $foundMatchingTag = false;
 
 if ($rs["num"] == 0) {
 
 return i18n('cn_no_constructs_linked_to_node');
 } else {
 
 while (list($_k,$_v) = each($rs["arr"])) {
 
 $constructIds[] = $_v["id"];
 
 
 if ($_v["keyword"] && stristr($tagname,$_v["keyword"]) && ($l = strlen($_v["keyword"])) > $_l) {
 
 
 $cid = $_v["id"];
 
 if ($_v["autoenable"]) {
 $enabled = 1;
 }
 
 $_l = $l;
 $foundMatchingTag = true;
 }
 
 }
 }
 
 
 if (!$foundMatchingTag) {
 $cid = $constructIds[0];
 }
 
 tag_create($tagname,$id,"template",$cid,0,$enabled);
 }
 $offset = $pos1 + 1;
}

 if( $hasChanged ) {
 objtranslatecache_clear( $id, $T_TEMPLATE );
 }
}

function cmd_template_tagdel($id) {


 $sql = "SELECT id, name, pub, template_id FROM templatetag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while(list($key,$val) = each($rs["arr"])) {
 if ($val["pub"] == 1) {
 $sql = "SELECT contenttag.id FROM contenttag, page WHERE contenttag.name = '".sqlslashes($val["name"])."' AND 
contenttag.content_id = page.content_id AND page.template_id = ".sqlf_tl_num($val["template_id"]);
 $rs2 = query($sql);
 if ($rs2["num"] > 0) {
 while(list($k,$v) = each($rs2["arr"])) tag_del($v["id"],"content");
 }
 }
 tag_del($val["id"],"template");
 }
 }
 
}

function cmd_template_tagsync($id) {
 $sql = "SELECT id, name, pub, template_id FROM templatetag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 node_include("dirt");
 while(list($key,$val) = each($rs["arr"])) {
 set_time_limit(0);
 if ($val["pub"] == 1) {
 
 $sql = "SELECT content_id FROM page WHERE template_id = ".sqlf_tl_num($val["template_id"]);
 $rs2 = query($sql);
 if ($rs2["num"] > 0) 
 while(list($k,$v) = each($rs2["arr"])) {
 set_time_limit(0);
 tag_copy($val["template_id"],"template",$v["content_id"],"content", false);
 triggerEvent(T_PAGECONTENT, $v["content_id"], EVENT_CN_CONTENT | EVENT_UPDATE, new EventObject());
 }
 
 $sql = "SELECT contenttag.id FROM contenttag, page WHERE contenttag.name = '".sqlslashes($val["name"])."' AND
contenttag.content_id = page.content_id AND page.template_id = ".sqlf_tl_num($val["template_id"]);
 $rs2 = query($sql);
 if ($rs2["num"] > 0) {
 while(list($k,$v) = each($rs2["arr"])) {
 $tmp .= sqlf_tl_num($v["id"]).",";
 }
 $sql = "UPDATE contenttag SET enabled = 1 WHERE enabled = 3 AND id IN ($tmp-1)";
 query($sql);
 }
 } else if ($val["pub"] == 0) {
 
 $sql = "SELECT contenttag.id, page.content_id FROM contenttag, page WHERE contenttag.name = '".sqlslashes($val["name"])."' AND
contenttag.content_id = page.content_id AND page.template_id = ".sqlf_tl_num($val["template_id"]);
 $rs2 = query($sql);
 if ($rs2["num"] > 0) {
 while(list($k,$v) = each($rs2["arr"])) {
 set_time_limit(0);
 tag_del($v["id"],"content");
 triggerEvent(T_PAGECONTENT, $v["content_id"], EVENT_CN_CONTENT | EVENT_UPDATE, new EventObject());
 }
 }
 }
 }
 }
}

function html_parsetags($html) {

$lhtml = strtolower($html);

$img = Array();

while (strpos($lhtml,"<img")) {

 $pos = strpos($lhtml,"<img");

 ereg("<img[^>]*src=\"([^\"]*)\"",$html,$regs);
 $img[] = $regs[1];

 $html = substr($html,$pos+1);
 $lhtml = substr($lhtml,$pos+1);
}

return $img;

}

function get_construct_of_type($type_id) {
 $sql = "SELECT construct_id FROM part WHERE type_id = ".sqlf_tl_num($type_id);
 $rs = query($sql);
 while (list($key,$val) = each($rs["arr"])) {
 $sql = "SELECT count(id) AS c FROM part WHERE construct_id = '".sqlf_escaped($val["construct_id"])."'";
 $rs2 = query($sql);
 if ($rs2["arr"][0]["c"] == 1) return $val["construct_id"];
 }
 return 0;
}

function template_fetch($tid,$url) {

 global $FOLDER_ID, $TAG_PREFIX, $TEMPLATE_ID, $T_TEMPLATETAG, $DEBUG;

 $source = implode("",file($url));
 $baseurl = substr($url,0,strrpos($url,"/")+1);

 $files = Array();
 $files = get_mlproperty($source,"img","src",$files);
 $files = get_mlproperty($source,"link","href",$files);
 $files = get_mlproperty($source,"script","src",$files);
 $files = get_mlproperty($source,"td","background",$files);
 $files = get_mlproperty($source,"body","background",$files);

 $image_construct_id = get_construct_of_type(6);
 $file_construct_id = get_construct_of_type(8);
 if (!$image_construct_id || !$file_construct_id) halt(7,"no fileurl($file_construct_id) or imageurl($image_construct_id) tagtype found.");

 while (list($key,$val) = each($files)) {
 
 if (!strrpos($key,"/")) $filename = $key;
 else $filename = substr($key,strrpos($key,"/")+1);
 
 if (!strpos($key,"://")) {
 if ($key[0] == "/") {
 $p = strpos($baseurl,"://")+3;
 $domend = strpos($baseurl,"/",$p+1);
 $root = substr($baseurl,0,$domend);
 $fileurl = $root.$key;
 }
 else $fileurl = $baseurl.$key;
 } else $fileurl = $key;

 if (strpos($filename,"'") || strpos($filename,"\"")) continue;
 
 $i = 0;
 unset($fp);
 while (!$fp && $i < 3) {
 $fp = @fopen($fileurl,"r");
 $i++;
 }
 if ($fp) {
 if ($DEBUG["template_fetch"]) echo "$fileurl done.<br>\n";
 $myfile = "";
 while ($line = fread($fp,4096)) {
 $myfile .= $line;
 }
 fclose($fp);

 
 $file_id = dbfile_exists($filename,$FOLDER_ID);
 if (!$file_id) $file_id = cmd_file_create($filename, $FOLDER_ID, "");
 if (strpos($filename,"jpg")) $type = "image/jpeg";
 else if (strpos($filename,"gif")) $type = "image/gif";
 else if (strpos($filename,"css")) $type = "text/css";
 else $type = "application/octet-stream";
 cmd_file_data($file_id,$myfile,strlen($myfile),$type);

 
 if ($type == "image/jpeg" || $type == "image/gif") {
 $construct_id = $image_construct_id;
 } else $construct_id = $file_construct_id; 
 $tag = cmd_tag_generate($construct_id,$tid,"templatetag","template");
 $source = str_replace($key,$tag["name"],$source);
 cmd_tagpart_touch($T_TEMPLATETAG,$tag["id"]);
 $sql = "UPDATE templatetag SET enabled = 1 WHERE id = ".sqlf_tl_num($tag["id"]);
 query($sql);
 $sql = "SELECT * from value WHERE templatetag_id = ".sqlf_tl_num($tag["id"]);
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row ){
 cmd_update_value( "", $file_id, false, "template", $tag["id"], $row["id"] ); 
 }
 } else if ($DEBUG["template_fetch"]) echo "<font color=red>$fileurl failed.</font><br>\n";
 }

 template_value($tid,$source);
}

function template_fetch_2($tid,$url) {
 global $TMPPATH, $SID, $SESSION_TOKEN, $FOLDER_ID, $TOOLPATH, $T_TEMPLATETAG, $ERROR, $TAG_FORMAT, $FEATURE, $TEMPLATE_FETCH_2_CUSTOM_WGET, $converttoutf8;

 
 $image_construct_id = get_construct_of_type(6);
 $file_construct_id = get_construct_of_type(8);

 
 
 
 $tmpdir = $TMPPATH."/".sha1($SESSION_TOKEN);

 
 @system("rm -Rf $tmpdir");
 @mkdir("$tmpdir");
 chdir("$tmpdir");

 
 $wgetcmd = "$TOOLPATH/wget";
 
 if( $FEATURE["template_fetch_2_custom_wget"] && $TEMPLATE_FETCH_2_CUSTOM_WGET ) {
 $wgetcmd = "$TEMPLATE_FETCH_2_CUSTOM_WGET";
 }

 $cmd = "$wgetcmd -nd -U \"Mozilla/4.0 (compatible; MSIE 6.0b; Windows NT 4.0; .NET CLR 1.0.3705)\" ".escapeshellarg($url);
 system($cmd);
 $d = dir("$tmpdir");
 while ($entry = $d->read()) {
 if ($entry != "." && $entry != "..") $startpage = $entry;
 }

 if (!$startpage) {
 $ERROR["url"] = i18n("url_loading_failed");
 return false;
 } else {
 
 unlink("$tmpdir/$startpage");
 }

 
 $cmd = "$wgetcmd -nd -k -H -U \"Mozilla/4.0 (compatible; MSIE 6.0b; Windows NT 4.0; .NET CLR 1.0.3705)\" -p ".escapeshellarg($url);
 system($cmd);
 $f = file("$tmpdir/$startpage");
 $source = implode("",$f);
 if ($converttoutf8) {
 $source = utf8_encode($source);
 }


 
 $d = dir("$tmpdir");
 while($entry = $d->read()) {
 if ($entry != "." && $entry != ".." && strpos($entry,".")) {
 
 
 $file_id = dbfile_exists($entry,$FOLDER_ID);
 if (!$file_id) $file_id = cmd_file_create($entry, $FOLDER_ID, "");
 $fp = @fopen($entry,"r");
 unset($myfile);
 if ($fp) {
 while ($line = fread($fp,4096)) {
 $myfile .= $line;
 }
 }
 @fclose($fp);

 if (strpos($entry,".gif")) {
 $type = "image/gif";
 $construct = $image_construct_id;
 } else if (strpos($entry,".jpg")) {
 $type = "image/jpeg";
 $construct = $image_construct_id;
 } else if (strpos($entry,".css")) {
 $type = "text/css";
 $construct = $file_construct_id;
 } else {
 $type = "application/octet-stream";
 $construct = $file_construct_id;
 }
 cmd_file_data($file_id,$myfile,strlen($myfile),$type);

 
 $keyword = substr($entry,0,strpos($entry,"."));
 $keyword = ereg_replace("[^$TAG_FORMAT]","",$keyword);
 $tag = cmd_tag_generate($construct,$tid,"templatetag","template",$keyword);
 cmd_tagpart_touch($T_TEMPLATETAG,$tag["id"]);
 $sql = "UPDATE templatetag SET enabled = 1 WHERE id = ".sqlf_tl_num($tag["id"]);
 query($sql);
 $sql = "UPDATE value SET value_ref = ".sqlf_tl_num($file_id)." WHERE templatetag_id = ".sqlf_tl_num($tag["id"]);
 query($sql);

 
 $source = ereg_replace("\"$entry\"","\"".$tag["name"]."\"",$source);
 $source = ereg_replace("'$entry'","'".$tag["name"]."'",$source);
 $source = ereg_replace("\"[^\"]*$entry\"","\"".$tag["name"]."\"",$source);
 $source = ereg_replace("'[^']*$entry'","'".$tag["name"]."'",$source);
 $source = str_replace($entry,$tag["name"],$source);
 }
 }
 $d->close();

 
 @system("rm -Rf $tmpdir");

 
 template_value($tid,$source);
}
 

?>
