<?

global $XNL_PATH;
@include_once("$XNL_PATH/config.inc.php");
 






function xnl_func_param ($xml, $param_name, $default = "")
{

 $startpos = strpos(strtolower($xml), '<'.$param_name.'>');
 if ($startpos === false)
 {
 return $default;
 }
 $endpos = strpos(strtolower($xml), '</'.$param_name.'>');
 $param_value = substr ($xml, $startpos + strlen($param_name) + 2, $endpos - ($startpos + strlen($param_name) + 2));
 return $param_value;

}












function dbSetCharset( $db, $charset, &$info, $useGlobalConfig = true ) {

 global $DB_DEFAULT_CHARSET;
 if ( !$charset && $useGlobalConfig ) {
 $charset = $DB_DEFAULT_CHARSET;
 }

 if ( !$charset ) {
 
 return true;
 }
 
 if ( !get_class($db) == "DB_mysql" ) {
 $info->error("set_charset", "Unsupported db type: ".get_class($db));
 return false;
 }
 
 $rs = $db->query("SET NAMES '$charset'");
 if ( DB::isError($res) ) {
 $info->error("set_charset", "Could not set charset '$charset'; ".$res->getMessage() );
 return false;
 }
 
 return true;
}

function pear_query( $sql, $db, &$info )
{
 $ret = array();
 $ret["arr"] = array();

 
 $res = $db->query($sql);
 if (DB::isError($res))
 {
 $info->info( "sql", $sql);
 $info->error( "select", $res->getMessage() );
 $ret["status"] = false;
 return $ret;
 }
 
 $row = $res->fetchRow(DB_FETCHMODE_ASSOC);
 while ( $row )
 {
 
 if (DB::isError($row))
 {
 
 $info->error( "fetchRow", $row->getMessage() );
 $ret["status"] = false;
 return $ret;
 }
 
 $ret["arr"][] = $row;
 
 
 $row = $res->fetchRow(DB_FETCHMODE_ASSOC);
 }
 $res->free();
 
 $ret["num"] = count( $ret["arr"] );
 $ret["status"] = true;
 return $ret;
}

function get_contentmap_textattribute($contentid,$name,&$db,&$info,$noCache=false) {
 static $attribCache = array();
 if ($noCache) {
 $sql = "SELECT value_text FROM contentattribute WHERE contentid = '$contentid' AND name = '".addslashes($name)."'";
 $rs = pear_query($sql,$db,$info);
 return $rs["arr"][0]["value_text"];
 } else if (!isset($attribCache[$contentid])) {
 $sql = "SELECT name, value_text FROM contentattribute WHERE contentid = '$contentid'";
 $rs = pear_query($sql,$db,$info);
 if (is_array($rs["arr"])) {
 foreach ($rs["arr"] as $row) 
 $attribCache[$contentid][$row["name"]] = $row["value_text"];
 } else {
 $attribCache[$contentid] = array();
 }
 return $attribCache[$contentid][$name];
 } else {
 return $attribCache[$contentid][$name];
 }
 return "";
}


define("T_PAGE",10007);
define("T_FOLDER",10002);
define("CT_FILE",10008);

?>
